' SSS.BAS                  (c) 2001 by Charles J. Olson
'
' by: Chuck Olson
'     WB9KZY
'     Jackson Harbor Press
'     RR1, Box 91C
'     Washington Island, WI  54246
'     email:  jacksonharbor@att.net
'     http://jacksonharbor.home.att.net/
'
'  ***********
'  * WARNING *
'  ***********
'
'  This program has only been tried by me on a DOS 6.2 PC clone - a
'  an old Tenex 486SLC-2.  It has worked on this machines without incident.
'  However, it may not work on your computer/SSS or it may even kill your
'  machine and/or the SSS dead!
'
'  Proceed at your own risk!
'
'
'   Introduction:
'
'   The SSS from the Arizone sQRorPions is a very useful kit.  But there
'   are times when it would be handy (charting the drift of a VFO) to have
'   a personal computer connected to the SSS.  This program (SSS.bas) along
'   with some minimal hardware attached to the parallel printer port of
'   an IBM compatible personal computer will allow the user to display,
'   datalog and calculate with the frequency readings from the SSS counter.
'
'   The program operates the SSS as the operator does, by pressing the
'   switch and "listening" to the sidetone.
'   The program can control the switch input of the SSS using an open
'   collector pin on the parallel port.  The program decodes the Morse
'   code output (with a simple diode detector) of the SSS and displays the
'   result on the screen.  In addition, the data is taken at specified
'   intervals and is written to a disk file along with the reading number
'   and some documentary data.
'
'   The data file can then be imported into a spreadsheet program (I use
'   Quattro Pro) and the results can be easily graphed.
'
'   The software can certainly be improved and extended to other platforms.
'
'   Users of the Island Keyer may recognize the hardware and software from
'   the Memload program - this program is basically the same with the
'   addition of the Morse decode routine.
'
'
'
'   Interface:
'
'   This program works by using an open-collector output from a PC
'   LPT printer port to actuate the switch inputs of the SSS.
'   An input pin on the LPT port is connected to a tone detector
'   circuit which is in turn connected to the tone output of the SSS.
'
'   You may not need the 74HC14 buffer chip, it depends on how "strong"
'   the pullups are on your LPT port.  You may also use a 74HCT14 in place
'   of the 74HC14.  The HC14 and HCT14 have Schmidt trigger (hysteresis) input
'   circuitry. The hardware required is shown in the following diagram:
'   Note that the .1 uf capacitor and 51k ohm resistor are suitable for the
'   74HC14 and 1n34 diode, but the values may need to be increased if the
'   diode or inverter type are changed.
'
'
'SSS switch input    <----------------------------------< lpt pin 16
'pin 4                                                      (/init)
'
'         74HC14        1N34                   74HC14
'pins:   13  12 11  10   | \  |        pins: 1   2  3   4
'          |\     |\     |  \ |               |\     |\
'SSS   >---| >o---| >o---|   >|---x-------x---| >o---| >o--> lpt pin 11
'chip      |/     |/     |  / |   |       |   |/     |/       (Busy)
'tone                    | /  |   |       |
'output pin 3 of 74HC00           |      <
'                                 |       \
'                             ---------    >
'                       .1 uf ---------   /   51 k ohms
'                                 |      <
'                                 |       \
'                                 |        >
'                                 |       /
'                                 |      <
'                                 |       \
'                                 |        >
'                                 |       |
'                                 |       |
'SSS ground        <--------------x-------x-------------< lpt pins 18-25
'                                                               (ground)
'
'
'       unused gates on 74HC14             power connection on 74HC14
'pins:  9    8             5   6            pin 7: ground  pin 14: +5V
'        |\                 |\
' gnd>---| >o--->    gnd>---| >o--->
'        |/                 |/
'
'
'
'      LPT 25 pin D connector(rear view):
'
'        13  12  11  10   9   8   7   6   5   4   3   2   1
'      -------------------------------------------------------
'       \ o   o   o   o   o   o   o   o   o   o   o   o   o /
'        \  o   o   o   o   o   o   o   o   o   o   o   o /
'         ------------------------------------------------
'          25  24  23  22  21  20  19  18  17  16  15  14
'
'
'
'   Operation:
'
'   Invoke the DOS program, MSD, to find out the port address of your
'   LPT port.  This should be either 03BCH, 0378H or 0278H.
'
'   Be sure to have the SSS powered up and connected before attempting
'   to run the program.  Also, manuall put the SSS into the mode you
'   want before running the program - I use the L option for the full
'   readout of the frequency.
'
'   To invoke the program the first time type:  QBASIC SSS
'
'   Uncomment the appropriate line below which corresponds to the
'   base address of your LPT port by deleting the ' in the first column.
'
'
CLS
REM When using the BASIC "OUT" command hand shaking is not necessary but you must
REM have the correct port number. This simple QBASIC program looks at the bios jump
REM table and returns with Lp1 set to the correct address for LPT-1.
'baseadr = 888   'used for Port Address 0378H
'baseadr = 956   'used for Port Address 03BCH
'baseadr = 632   'used for Port Address 0278H
'
'   Then save the program.
'
'   Power up the SSS BEFORE connecting the cable to the PC.
'   Connect the interface hardware to the PC and the keyer - then
'   run the program to check things out.
'
'   Hit the esc key to bail out of the program.  If esc
'   doesn't work, you will have to reset the PC.
'
'
IF baseadr = 0 THEN PRINT "You need to select the LPT Base Address!!" ELSE 0
STOP  'see the verbage above if the program stops here.
0 statin = baseadr + 1
ctrlout = baseadr + 2
DIM a(122)      ' morse code table
GOSUB 60        ' load the table with Morse data
ON ERROR GOTO 55
again:
PRINT "PC datalogger for SSS frequency counter, 8/17/2001, Chuck Olson, WB9KZY"
PRINT
REM
REM init the frequency reading counter
readcount = 0
REM
REM prompt the operator to setup the SSS
PRINT "Manually set the SSS for desired configuration, normally long (L), fast readout"
PRINT
REM
REM get the number of seconds between readings from the user
INPUT "enter the number of seconds (at least 10) between readings: "; seconds
PRINT
IF seconds < 10 THEN seconds = 10
REM
REM open the data output file
INPUT "Enter data output filename: "; n$
PRINT
OPEN n$ FOR OUTPUT AS #2
REM
REM denote the date, time and number of seconds between readings
PRINT #2, DATE$, TIME$, seconds, " seconds between readings"
REM
REM enter a comment line, what is being tested and why
PRINT "Enter comment line (no commas in the comment!) "
INPUT comment$
PRINT
PRINT #2, comment$
PRINT #2, "Frequency, reading number"
INPUT "Press Enter to start measuring  "; comment$
PRINT "                                                               "
PRINT "Press Esc to stop measuring"
TIMER ON
    ON TIMER(seconds) GOSUB decode
REM
REM get the first reading at roughly zero seconds
GOSUB 15        'get the dit length and start the measurement
GOSUB decode2
REM
REM measure the temperature and frequency
measure:        'endless loop
GOTO measure
STOP
END


decode:
' decode is a routine to "listen" to the SSS tone output and convert/display
' the Morse characters.
'
' Each code element is measured and compared to the dit length measured
' during the switch press and release (PAR).  If a mark (tone on) is less
' than 1.5 times a dit, then it's considered a dit.  If the mark is greater
' than 1.5 times a dit, then it's a dah.
'
' The spaces (tone off) are handled similarly.  If the space is less than
' 1.5 times a dit, then it's a dit space within a character.  If the space
' is greater than 1.5 times a dit, it's a character space.  If the space
' is greater than 4 times a dit, it's a word space.
OUT ctrlout, 0          'turn on the switch
OUT ctrlout, 4          'turn off the switch
decode2:                'alternate entry point for routine
LOCATE 20, 10
ditplushalf = dit * 1.5
nextchar:
char = 1
getele:
GOSUB measmark
IF mark < ditplushalf THEN char = char * 2
IF mark >= ditplushalf THEN char = char * 2 + 1
GOSUB measspace
IF space < ditplushalf THEN GOTO getele
FOR i = 48 TO 90
IF char = a(i) THEN GOTO gotit
NEXT i
gotit:
IF i = 68 THEN GOTO nextchar            'ignore a D
IF i = 69 THEN GOTO nextchar            'ignore an E
IF i = 70 THEN GOTO nextchar            'ignore an F
IF i = 76 THEN GOTO nextchar            'ignore an L
IF i = 82 THEN PRINT ",";  ELSE PRINT ; CHR$(i);    'replace R with ,
IF i <> 82 THEN PRINT #2, CHR$(i);
IF space > 4 * dit THEN IF i = 82 GOTO nextchar ELSE GOTO over     'this measurement is complete
GOTO nextchar
over:
PRINT "   Hz          "
LOCATE 22, 10
PRINT readcount; " measurements, ", readcount * seconds / 60; " minutes         "
PRINT #2, ","; readcount
readcount = readcount + 1
RETURN


measmark:
'  first, wait for the mark to start - note that the printer port logic is
'  is reversed, if bit 7 of statin is a 1, then the tone is off
'  if bit 7 of statin is a 0, then the tone is on
mark = 0
low:
        stat = INP(statin) AND 128
        IF stat = 128 THEN GOTO low
'
' second, measure the length of the mark
high:
        stat = INP(statin) AND 128
    mark = mark + 1
    IF stat = 0 THEN GOTO high
IF INKEY$ = CHR$(27) THEN END   '27 is the ASCII code for Esc.
RETURN


measspace:
' first, wait for the space to start - note that the printer port logic is
'  is reversed, if bit 7 of statin is a 1, then the tone is off
'  if bit 7 of statin is a 0, then the tone is on
high2:
        stat = INP(statin) AND 128
        IF stat = 0 THEN GOTO high2
'
' second, measure the length of the space
space = 0       'initialize the space counter
low2:
        stat = INP(statin) AND 128
        space = space + 1
        IF space > 4 * dit THEN GOTO endspace
        IF stat = 128 THEN GOTO low2
endspace:
IF INKEY$ = CHR$(27) THEN END   '27 is the ASCII code for Esc.
RETURN


REM pin 16, dah, (bit 2) is pos logic and must be set to 1 to output a 1

REM     press and release the switch routine
15    OUT ctrlout, 0 'turn on the switch
    OUT ctrlout, 4 'turn off the switch
20    stat = INP(statin) AND 128
    IF stat = 128 THEN 20
30  stat = INP(statin) AND 128
    dit = dit + 1
    IF stat = 0 THEN 30
'    OUT ctrlout, 4 'turn off the switch
    RETURN  ' end of dah routine


55 CLOSE 1
END

60 'first, load all locations of the array a with 0
FOR i = 0 TO 122
a(i) = 0
NEXT i
' second, load the Morse equivalents to the ASCII numbers & letters
' Character structure from Dave Gwillym, KB2TQX
' Right justified storage of the character:
'                                       dit = 0
'                                       dah = 1
' The leftmost 1 is a start bit - the byte is left shifted until a
'       1 is seen, then the dits and dahs are shifted out for a
'       total of 8 shifts - this holds most normal characters.
' Note that the table position is what is stored in the eeprom
'
' The table specifies only numbers and letters
'
'binary Morse    character      hex
a(48) = &H3F  '0011 1111'     ;0 ascii        30 hex
a(49) = &H2F  '0010 1111'     ;1              31
a(50) = &H27  '0010 0111'     ;2              32
a(51) = &H23  '0010 0011'     ;3              33
a(52) = &H21  '0010 0001'     ;4              34
a(53) = &H20  '0010 0000'     ;5              35
a(54) = &H30  '0011 0000'     ;6              36
a(55) = &H38  '0011 1000'     ;7              37
a(56) = &H3C  '0011 1100'     ;8              38
a(57) = &H3E  '0011 1110'     ;9              39
a(65) = &H5   '0000 0101'     ;A              41 hex
a(66) = &H18  '0001 1000'     ;B              42
a(67) = &H1A  '0001 1010'     ;C              43
a(68) = &HC   '0000 1100'     ;D              44
a(69) = &H2   '0000 0010'     ;E              45
a(70) = &H12  '0001 0010'     ;F              46
a(71) = &HE   '0000 1110'     ;G              47
a(72) = &H10  '0001 0000'     ;H              48
a(73) = &H4   '0000 0100'     ;I              49
a(74) = &H17  '0001 0111'     ;J              4A
a(75) = &HD   '0000 1101'     ;K              4B
a(76) = &H14  '0001 0100'     ;L              4C
a(77) = &H7   '0000 0111'     ;M              4D
a(78) = &H6   '0000 0110'     ;N              4E
a(79) = &HF   '0000 1111'     ;O              4F
a(80) = &H16  '0001 0110'     ;P              50
a(81) = &H1D  '0001 1101'     ;Q              51
a(82) = &HA   '0000 1010'     ;R              52
a(83) = &H8   '0000 1000'     ;S              53
a(84) = &H3   '0000 0011'     ;T              54
a(85) = &H9   '0000 1001'     ;U              55
a(86) = &H11  '0001 0001'     ;V              56
a(87) = &HB   '0000 1011'     ;W              57
a(88) = &H19  '0001 1001'     ;X              58
a(89) = &H1B  '0001 1011'     ;Y              59
a(90) = &H1C  '0001 1100'     ;Z              5A
RETURN

